<?php
require_once('guiconfig.inc');
require_once('.api.php');

global $config,$ipqs;
$ipqs['config']		= &$config['installedpackages']['ipqualityscore']['config'][0];

$pconfig = array();

$pconfig['enable_vpn_proxy']            =   $ipqs['config']['vpnproxy']['enabled'] ? : '';
$pconfig['vpn_proxies_fraud_scores']    =   $ipqs['config']['vpnproxy']['fraud'] ? : '';
$pconfig['vpn_proxy_filtering']         =   explode(',', $ipqs['config']['vpnproxy']['block']) ? : '';
$pconfig['vpn_proxy_country']           =   explode(',', $ipqs['config']['vpnproxy']['countires']) ? : '';
$pconfig['transaction_strictness']      =   $ipqs['config']['vpnproxy']['strictness'] ? : '';
$pconfig['allow_public_access_points']  =   $ipqs['config']['vpnproxy']['publicap'] ? : '';
if($_POST){
    if(isset($_POST['save'])){
        $ipqs['config']['vpnproxy']['enabled']        =   $_POST['enable_vpn_proxy']   ? : '';
        $ipqs['config']['vpnproxy']['risk']           =   $_POST['vpn_proxies_risk_scores'] ? : '';
        $ipqs['config']['vpnproxy']['fraud']          =   $_POST['vpn_proxies_fraud_scores']   ? : '';
        $ipqs['config']['vpnproxy']['block']          =   implode(',',$_POST['vpn_proxy_filtering']);
        $ipqs['config']['vpnproxy']['countires']      =   implode(',',$_POST['vpn_proxy_country']);
        $ipqs['config']['vpnproxy']['strictness']     =   $_POST['transaction_strictness']   ? : '';
        $ipqs['config']['vpnproxy']['publicap']       =   $_POST['allow_public_access_points']   ? : '';
        if($ipqs['config']['vpnproxy']['enabled']){
            $ipqs['bin']['start']();
        }else{
            $ipqs['bin']['stop']();
        }

        if(!isset($input_error)){
            write_config('[IPQualityScore] save General settings');
            header('Location: /ipqualityscore/index.php');
        }
    }
}

$pgtitle = array(gettext('Firewall'), gettext('IPQualityScore'));
$pglinks = array('', '@self');
include('head.inc');

display_top_tabs($ipqs['fnc']['nav'](), true);

if (isset($input_errors)) {
    print_input_errors($input_errors);
}

$form = new Form('Save');
$section = new Form_Section('General Settings');
if(strlen($ipqs['config']['oauth']['access_token']) !== 128){
    $section->addInput(new Form_Button(
        'oauthkey',
        gettext('Login'),
        '#'
    ))->setHelp('To use <b>IPQualityScore</b> you are required have an account<br />'
        . 'Please  <a href="https://www.ipqualityscore.com/create-account">create an account</a>.'
    );
}else{
    $section->addInput(new Form_Button(
        'oauthkey_del',
        gettext('Delete Key'),
        '#'
    ))->setAttribute('href','https://' . $_SERVER['SERVER_ADDR'] . '/ipqualityscore/oauth.php?del_key');
}
$form->add($section);


$section = new Form_Section('VPN & Proxy detection');
$section->addInput(new Form_Checkbox(
    'enable_vpn_proxy',
    'Enable Service',
    'Enable',
    $pconfig['enable_vpn_proxy'] === 'on' ? true:false,
    'on'
));
if(strlen($ipqs['config']['oauth']['access_token']) === 128){
    if($pconfig['enable_vpn_proxy'] === 'on'){
        
        $section->addInput(new Form_Input(
            'vpn_proxies_fraud_scores',
            gettext('Fraud Score'),
            'number',
            $pconfig['vpn_proxies_fraud_scores'],
            [ 'min' => 0, 'max' => 100, 'step' => 5, 'placeholder' => 'enter score 0-100' ]
        ))->setHelp('<b>Fraud Scores >= 75 are suspicious</b>, but not necessarily fraudulent. <br/>We recommend flagging or blocking traffic with Fraud Scores >= 85, <br />but you may find it beneficial to use a higher or lower threshold.'
        . '<b><a href="https://www.ipqualityscore.com/documentation/proxy-detection/overview">Read more</a></b>'
        );
    
        
        $section->addInput(new Form_Select(
            'vpn_proxy_filtering',
            'Types of proxies to filter',
            $pconfig['vpn_proxy_filtering'],
            ['None', 'VPN', 'Proxies', 'TOR/I2P'],
            true
        ));

        $section->addInput(new Form_Select(
            'vpn_proxy_country',
            'Black list countries',
            $pconfig['vpn_proxy_country'],
            $ipqs['vars']['countires'],
            true
        ));

        $section->addinput(new Form_Select(
            'transaction_strictness',
            'Transaction Strictness',
            $pconfig['vpn_proxy_transaction_strictness'],
            [ 0,1,2]
        ));

        $section->addinput(new Form_Checkbox(
            'allow_public_access_points',
            'Allow Public Access Points',
            $pconfig['vpn_proxy_allow_public_access_points']=== 'on' ? true:false,
            'on'
        ));

        $section->addInput(new Form_Select(
            'vpn_proxy_caching',
            'Cache Duration',
            $pconfig['vpn_proxy_caching'],
            [	'1h'	=> '1 hour',
                '3h'	=> '3 hour',
                '6h'	=> '6 hour',
                '12h'	=> '12 hour',
                '1d'		=> '1 day'
            ]
        ))->setHelp('Depeneding on the ammount of traffic and the ammount of disk you may need a shorter cache time.')->setAttribute('style', 'width: auto');
    }else{
        
        $section->addInput(new Form_Input(
            'vpn_proxies_fraud_scores',
            gettext('Fraud Score'),
            'number',
            $pconfig['vpn_proxies_fraud_scores'],
            [ 'min' => 0, 'max' => 100, 'step' => 5, 'placeholder' => 'enter score 0-100' ]
        ))->setAttribute('disabled', 'true')->setHelp('<b>Fraud Scores >= 75 are suspicious</b>, but not necessarily fraudulent. <br/>We recommend flagging or blocking traffic with Fraud Scores >= 85, <br />but you may find it beneficial to use a higher or lower threshold.'
        . '<b><a href="https://www.ipqualityscore.com/documentation/proxy-detection/overview">Read more</a></b>'
        );

        
        
        $section->addInput(new Form_Select(
            'vpn_proxy_filtering',
            'Types of connections to filter',
            $pconfig['vpn_proxy_filtering'],
            [0 => 'None', 1 => 'VPN', 2 => 'Proxies', 3 => 'TOR'],
            true
        ))->setAttribute('disabled', 'true');

        $section->addInput(new Form_Select(
            'vpn_proxy_country',
            'Black list countries',
            $pconfig['vpn_proxy_country'],
            $ipqs['vars']['countires'],
            true
        ))->setAttribute('disabled', 'true');

        $section->addinput(new Form_Select(
            'transaction_strictness',
            'Transaction Strictness',
            $pconfig['vpn_proxy_transaction_strictness'],
            [ 0,1,2]
        ))->setAttribute('disabled', 'true');

        $section->addinput(new Form_Checkbox(
            'allow_public_access_points',
            'Allow Public Access Points',
            $pconfig['vpn_proxy_allow_public_access_points']=== 'on' ? true:false,
            'on'
        ))->setAttribute('disabled', 'true');


        $section->addInput(new Form_Select(
            'vpn_proxy_caching',
            'Cache Duration',
            $pconfig['vpn_proxy_caching'],
            [	'1h'	=> '1 hour',
                '3h'	=> '3 hour',
                '6h'	=> '6 hour',
                '12h'	=> '12 hour',
                '1d'		=> '1 day'
            ]
        ))->setAttribute('disabled', 'true')->setHelp('Depending on the amount of traffic you\'re processing a shorter cache time may be recommended')->setAttribute('style', 'width: auto');
    }
}else{
    $section =  new Form_Section('Oauth needs to be setup');
    $section->addInput(new Form_StaticText(
        'Notice',
        'Netmonitoring will only work once oauth configured.',
    ));
}


$form->add($section);

print($form);
  
?>
<script>
     document.addEventListener("DOMContentLoaded", function(event) {
        <?php 
            if(strlen($ipqs['config']['oauth']['access_token']) === 128){
        ?>
        document.getElementById("enable_vpn_proxy").addEventListener("click", function(){
            if(document.getElementById("enable_vpn_proxy").checked){
                document.getElementById("vpn_proxies_fraud_scores").removeAttribute('disabled');
                document.getElementById("vpn_proxy_filtering[]").removeAttribute('disabled');
                document.getElementById("vpn_proxy_caching").removeAttribute('disabled');
                document.getElementById("transaction_strictness").removeAttribute('disabled');
                document.getElementById("allow_public_access_points").removeAttribute('disabled');
                document.getElementById("vpn_proxy_country[]").removeAttribute('disabled');
            }else{
                document.getElementById("vpn_proxy_caching").setAttribute('disabled', true);
                document.getElementById("vpn_proxies_fraud_scores").setAttribute('disabled', true);
                document.getElementById("vpn_proxy_filtering[]").setAttribute('disabled', true);
                document.getElementById("transaction_strictness").setAttribute('disabled', true);
                document.getElementById("allow_public_access_points").setAttribute('disabled', true);
                document.getElementById("vpn_proxy_country[]").setAttribute('disabled', true);
            }
        });
        <?php }else{ ?>
        document.getElementById("oauthkey").addEventListener("click", function(){
            window.open(
                'https://ipqualityscore.com/oauth/pfsense/login?domain=<?php echo $_SERVER['SERVER_ADDR'];?>&path=%2Fipqualityscore%2Foauth.php',
                "_blank",
                "location=yes,height=600,width=520,scrollbars=yes,status=yes")
        });
        <?php } ?>
     });
</script>
<?php include("foot.inc"); ?>